#! /bin/bash
#_____________________________________________________________________________
#
# configuration section
# sigularity_project=/projappl/project_462000048:/projappl/project_462000048
singularity_sw=/project/project_465000454/icon/sw
singularity_rsync=/usr/bin/rsync,/usr/lib64/libslp.so.1
singularity_cmake=/usr/bin/cmake,/usr/share/cmake,/usr/lib64/librhash.so.0,/usr/lib64/libjsoncpp.so.19
singularity_pool=/appl/local/climatedt/pool/
singularity_container=/scratch/project_465000454/cpe/ccpe-rocm-5.4.1-16.0.1.1.sif
#_____________________________________________________________________________
#

module --force purge

singularity exec \
	    --rocm \
	    --bind "${singularity_pool}" \
	    --bind "${singularity_rsync}" \
            --bind "${singularity_cmake}" \
	    --bind "${singularity_sw}" \
            --bind $PWD \
	    --workdir "${singularity_work}" \
	    "$singularity_container" bash

#_____________________________________________________________________________
#
# Notes:
#
# - MPI RMA problem (HPE case 5367225191): unsolved
# - coupled model OpenMP/MPI problem: unsolved
# - runtime needs 'export SINGULARITY_BIND=/var/spool/slurmd/mpi_cray_shasta'
#   and 'module load craype-accel-amd-gfx90a rocm'
