#ifndef YACO_FDB_WRITER_HPP
#define YACO_FDB_WRITER_HPP

#include <fstream>
#include <memory>
#include <yaco/data_handler.hpp>

namespace yaco
{

class FDBWriter : public DataHandler {
  public:
    FDBWriter(const config::Value& doc);
    ~FDBWriter() override;
    void handle(Collection& collection, const chrono::DateTime& timestep) override;

  private:
    class GRIBMessage;
    class Impl;
    std::unique_ptr<Impl> impl_;
};

} // namespace yaco

#endif // YACO_FDB_WRITER_HPP
